Macro Align View to Face/es: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
mNo edit summary
Line 1: Line 1:
{{Macro/es|Name=Macro Align View to Face|Name/es=Macro Align View to Face|Description=This macro aligns the current view to a selected face|Author=Rockn|Version=1.0}}
{{Macro/es|Name=Macro Align View to Face|Name/es=Macro Align View to Face|Description=This macro aligns the current view to a selected face|Author=Rockn|Version=1.0|Date=2014-03-12}}


==Description==
==Description==

Revision as of 14:27, 29 September 2017

Macro Align View to Face

Descripción
This macro aligns the current view to a selected face

Versión macro : 1.0
Fecha última modificación : 2014-03-12
Autor : Rockn
Autor
Rockn
Descargar
None
Enlace
Versión Macro
1.0
Fecha última modificación
2014-03-12
Versión(es) FreeCAD
None
Acceso directo predeterminado
None
Ver también
None

Description

This macro rotates the current view to point perpendicularly at a selected face of an existing object.

How to use

  1. Select a face on an object
  2. Run the macro

Script

# -*- coding: utf-8 -*-
# Set the current view perpendicular to the selected face
# Place la vue perpendiculairement à la face selectionnee
# 2013 Jonathan Wiedemann, 2016 Werner Mayer

from pivy import coin

def pointAt(normal, up):
    z = normal
    y = up
    x = y.cross(z)
    y = z.cross(x)
   
    rot = App.Matrix()
    rot.A11 = x.x
    rot.A21 = x.y
    rot.A31 = x.z
   
    rot.A12 = y.x
    rot.A22 = y.y
    rot.A32 = y.z
   
    rot.A13 = z.x
    rot.A23 = z.y
    rot.A33 = z.z

    return App.Placement(rot).Rotation

s=Gui.Selection.getSelectionEx()
obj=s[0]
faceSel = obj.SubObjects[0]
dir = faceSel.normalAt(0,0)
cam = FreeCADGui.ActiveDocument.ActiveView.getCameraNode()

if dir.z == 1 :
    rot = pointAt(dir, App.Vector(0.0,1.0,0.0))
elif dir.z == -1 :
    rot = pointAt(dir, App.Vector(0.0,1.0,0.0))
else :
    rot = pointAt(dir, App.Vector(0.0,0.0,1.0))

cam.orientation.setValue(rot.Q)
Gui.SendMsgToActiveView("ViewSelection")